// Distributed under GNU General Public License (see license.txt for details).
//
//  Copyright (c) 2006 Shai Shalev-Shwartz and Yoram Singer.
//  All Rights Reserved.
//
// Function for reading data in binary format.
//

#include "dataset.h"

void DataSet::open(int &m, int &n, int &n_classes) {
  data_file = fopen(name_instance.c_str(),"r");

  if ( data_file == NULL ) {
    perror(name_instance.c_str());
  }

  unsigned int um, un, uk;

  infra::load_binary(data_file, um);
  infra::load_binary(data_file, un);

  label_file = fopen(name_label.c_str(),"r");

  if ( label_file == NULL ) {
    perror(name_label.c_str());
  }

  infra::load_binary(label_file, um);
  infra::load_binary(label_file, uk);

  m = (int) um;
  n = (int) un;
  n_classes = (int) uk;

  is_open = true;
}

void DataSet::reopen() {
  int m, n, k;

  close();
  open(m, n, k);
}

void DataSet::close() {

  fclose(data_file);
  fclose(label_file);

  is_open = false;
}

void DataSet::next(infra::vector_view instance, infra::vector_view gamma) {

  if ( !is_open ) {
    std::cerr << "Read while files are not open.\n";
    exit(-1);
  }

  instance.load_binary(data_file);
  gamma.load_binary(label_file);
}
