// Distributed under GNU General Public License (see license.txt for details).
//
//  Copyright (c) 2006 Shai Shalev-Shwartz and Yoram Singer.
//  All Rights Reserved.
//
// Header file for datasets.
//

#include <iostream>
#include <fstream>
#include <vector>

#include "infra/infra.h"

class DataSet {

 public:

  DataSet(std::string &instance_file_name,std::string &labels_file_name) :
    name_instance(instance_file_name), name_label(labels_file_name) {
    is_open = false;
  };


  void open(int &m, int &n, int &n_classes);

  void reopen();

  void next(infra::vector_view instance,infra::vector_view gamma);

  void close();

 protected:

  std::string name_instance; // name of the instances file
  std::string name_label; // name of the labels file

  FILE* data_file;  // a file descriptor for binary file of instances
  FILE* label_file; // a file descriptor for binary file of labels

  bool is_open;
};
